//+------------------------------------------------------------------+
//|                                                           ER.mq4 |
//|                                                 Kamil Gazizullin |
//|                                             forexman77@yandex.ru |
//+------------------------------------------------------------------+
#property copyright "Kamil Gazizullin"
#property link      "forexman77@yandex.ru"
#property version   "1.00"
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Lime
//--- input parameters
//--- buffers
double ExtMapBuffer1[];
extern int p=10;
double val_plus[];
double val_minus[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   IndicatorDigits(Digits+1);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
    int counted_bars=IndicatorCounted(),                      
    limit;
    double
    indicator_plus,indicator_minus,prirost,summa,ER;
   if(counted_bars>0)
      counted_bars--;
   limit=Bars-counted_bars;

   for(int i=0;i<limit;i++)
   { 
     indicator_plus=0;
     indicator_minus=0;
     ArrayInitialize(val_plus,0);
     ArrayInitialize(val_minus,0);
     for(int k=p;k>=0;k--)
      {
       ArrayResize(val_plus,p);
       ArrayResize(val_minus,p);
       val_plus[k]=iClose(Symbol(),Period(),i+k)-iClose(Symbol(),Period(),i+k+1);
       val_minus[k]=iClose(Symbol(),Period(),i+k+1)-iClose(Symbol(),Period(),i+k);
       if (val_minus[k] > 0){indicator_minus=indicator_minus+val_minus[k];}
       if (val_plus[k] > 0){indicator_plus=indicator_plus+val_plus[k];}
       }
       prirost=iClose(Symbol(),Period(),i)-iClose(Symbol(),Period(),i+p);
       summa=indicator_plus+indicator_minus;
       ER=MathAbs(prirost)/summa;
       ExtMapBuffer1[i]=ER;
   }
   return(0);
  }
//+------------------------------------------------------------------+
